

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel; 
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.border.TitledBorder;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileWriter;
import java.io.PrintStream;
import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;

import org.gjt.sp.jedit.Buffer;

import util.PlinguaCoreException;
import variants.am.AmSimulator;
import variants.am.AmVariantFactory;
import variants.am.gui.AmGuiModel;
import variants.am.gui.SystemPanel;
import factory.InputParser;
import factory.Psystem;
import factory.VariantFactory;
import org.gjt.sp.jedit.jEdit;
import org.jdom.Document;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import org.gjt.sp.jedit.View;
import javax.swing.JTabbedPane;




import java.io.*;


public class PlinguaConsole extends JPanel implements  ActionListener {

	private static final long serialVersionUID = 1L;
	private JTextArea jTextArea=null;
	private JTextArea jTextArea1=null;
	private JTextArea jTextArea2=null;
	private JScrollPane jScrollPane = null;
	private JScrollPane jScrollPane1 = null;
	private JScrollPane jScrollPane2 = null;
	private JToolBar jToolBar = null;
	private Component owner=null;
	private JButton jButton = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private PrintStream printStream=null;
	private PrintStream printStream1=null;
	private PrintStream printStream2=null;
	private Psystem psystem=null;
	private JTabbedPane jTabbedPane;
	public PlinguaConsole(Component owner)
	{
		this.owner=owner;
		initialize();
		
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setLayout(new BorderLayout());
		
		
		this.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createLineBorder(Color.gray, 1),
				"P-Lingua compiler",
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION,
				null,
				null));
		this.add(getJTabbedPane(), BorderLayout.CENTER);
		this.add(getJToolBar(), BorderLayout.SOUTH);
	
	}
	
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane==null)
		{
			jTabbedPane= new JTabbedPane();
			jTabbedPane.addTab("Errors", getJScrollPane());
			jTabbedPane.addTab("Warnings", getJScrollPane1());
			jTabbedPane.addTab("Messages", getJScrollPane2());
		}
		return jTabbedPane;
		
	}
	
	/**
	 * This method initializes jToolBar	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new JToolBar();
			jToolBar.setFloatable(false);
			jToolBar.add(getJButton());
			jToolBar.add(getJButton2());
			jToolBar.add(getJButton1());
		}
		return jToolBar;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Compile!");
			jButton.addActionListener(this);
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton1
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Clear");
			jButton1.addActionListener(this);
		}
		return jButton1;
	}
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Simulate!");
			jButton2.addActionListener(this);
		}
		return jButton2;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}
	
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jScrollPane1.setViewportView(getJTextArea1());
		}
		return jScrollPane1;
	}
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jScrollPane2.setViewportView(getJTextArea2());
		}
		return jScrollPane2;
	}
	private JTextArea getJTextArea(){
		if (jTextArea==null)
		{
			jTextArea=new JTextArea();
		
			jTextArea.setEditable(false);
			printStream=new MyPrintStream(jTextArea);
		}
		return jTextArea;
	}
	
	private JTextArea getJTextArea1(){
		if (jTextArea1==null)
		{
			jTextArea1=new JTextArea();
			jTextArea1.setEditable(false);
			printStream1=new MyPrintStream(jTextArea1);
		}
		return jTextArea1;
	}
	private JTextArea getJTextArea2(){
		if (jTextArea2==null)
		{
			jTextArea2=new JTextArea();
			jTextArea2.setEditable(false);
			printStream2=new MyPrintStream(jTextArea2);
		}
		return jTextArea2;
	}
	
	

	public void actionPerformed(ActionEvent e) {
		if ("Compile!".equals(e
				.getActionCommand()))
		{
			Buffer buffer=null;
			View view=jEdit.getActiveView();
			if (view!=null)
			{
				buffer=view.getBuffer();
				if (buffer!=null)
					compileBuffer(view,buffer);
			}
				
				
		}
		else
		if ("Clear".equals(e.getActionCommand()))
		{
			jTextArea.setText("");
			jTextArea1.setText("");
			jTextArea2.setText("");
		}
		if ("Simulate!".equals(e
				.getActionCommand()))
		{
			Buffer buffer=null;
			View view=jEdit.getActiveView();
			if (view!=null)
			{
				buffer=view.getBuffer();
				if (buffer!=null)
					simulate(view,buffer);
			}
				
				
		}
		
	}
	
	class MyPrintStream extends PrintStream
	{
		private JTextArea jTextArea=null;
		public MyPrintStream(JTextArea jTextArea)
		{
			super(new ByteArrayOutputStream());
			this.jTextArea=jTextArea;
		}

	
		@Override
		public void print(boolean arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(Boolean.toString(arg0));
		
		}

		@Override
		public void print(char arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(Character.toString(arg0));
			
		}

		@Override
		public void print(char[] arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(new String(arg0));
			
		}

		@Override
		public void print(double arg0) {
			jTextArea.append(Double.toString(arg0));
			
		}

		@Override
		public void print(float arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(Float.toString(arg0));
		
		}

		@Override
		public void print(int arg0) {
			jTextArea.append(Integer.toString(arg0));
			
		}

		@Override
		public void print(long arg0) {
			jTextArea.append(Long.toString(arg0));
		
		}

		@Override
		public void print(Object arg0) {
			jTextArea.append(arg0.toString());
			
		}

		@Override
		public void print(String arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(arg0);
			
		}

	

		@Override
		public void println() {
			// TODO Auto-generated method stub
			jTextArea.append("\n");
		
		}

		@Override
		public void println(boolean arg0) {
			jTextArea.append(Boolean.toString(arg0)+"\t\n");
			
		}

		@Override
		public void println(char arg0) {
			// TODO Auto-generated method stub
			jTextArea.append(Character.toString(arg0)+'\n');
			
		}

		@Override
		public void println(char[] arg0) {
			jTextArea.append(new String(arg0)+'\n');
			
		}

		@Override
		public void println(double arg0) {
			jTextArea.append(Double.toString(arg0)+'\n');
			
		}

		@Override
		public void println(float arg0) {
			jTextArea.append(Float.toString(arg0)+'\n');
		
		}

		@Override
		public void println(int arg0) {
			jTextArea.append(Integer.toString(arg0)+'\n');
		
		}

		@Override
		public void println(long arg0) {
			jTextArea.append(Long.toString(arg0)+'\n');
		
		}

		@Override
		public void println(Object arg0) {
			jTextArea.append(arg0.toString()+'\n');
		
		}

		@Override
		public void println(String arg0) {
			
			jTextArea.append(new String(arg0)+"\n");
			
		}

	
		
	}
	
	public boolean simulate(View view,Buffer buffer)
	{
		VariantFactory f = new AmVariantFactory();
		if (psystem==null)
			compileBuffer(view,buffer);
		if (psystem==null)
			return false;
		AmSimulator sim = (AmSimulator)f.createSimulator(psystem,true,false);
		JFrame frame = new JFrame("Simulator");
		
		AmGuiModel model = new AmGuiModel(sim);
		frame.setContentPane(new SystemPanel(model));
		frame.setSize(640,480);
		frame.setVisible(true);
		return true;
	}
	
	public boolean compileBuffer(View view, Buffer buffer)
	{
		String text="";
		jTextArea.setText("");
		jTextArea1.setText("");
		jTextArea2.setText("");
		for(int i=0;i<buffer.getLineCount();i++)
			text+=buffer.getLineText(i)+"\n";
		
		StringReader r = new StringReader(text);
		
			String path=buffer.getPath();
			int index =path.lastIndexOf(".");
			if (index==-1)
				path=path+".xml";
			else
				path=path.substring(0,index)+".xml";
			
			VariantFactory f = new AmVariantFactory();
			InputParser p=f.createInputParser("P-Lingua");
			p.setVerbosityLevel(5);
			p.setErrorChannel(getErrorPrintStream());
			p.setInfoChannel(getMsgPrintStream());
			p.setWarningChannel(getWarningPrintStream());
			p.setMsgChannel(getMsgPrintStream());
			try
			{
				Psystem ps=p.parse(r);
				if (ps!=null)
				{
					try
					{
						Document d = ps.getDocument();
						XMLOutputter x = new XMLOutputter(Format
								.getPrettyFormat());
						FileWriter fichero = new FileWriter(path);
						PrintWriter pw = new PrintWriter(fichero);
						x.output(d, pw);
						Buffer b=jEdit.getBuffer(path);
						if (b!=null)
							b.reload(view);
						else
							jEdit.openFile(view, path);
						psystem=ps;
						if (!"".equals(jTextArea.getText()))
								jTabbedPane.setSelectedIndex(0);
						else
						if (!"".equals(jTextArea1.getText()))
								jTabbedPane.setSelectedIndex(1);
						else
							jTabbedPane.setSelectedIndex(2);
						buffer.removeAllMarkers();
						buffer.addMarker('*', 3);
						buffer.updateMarkersFile(view);
						return true;
					}
					catch(IOException ex)
					{
						ex.printStackTrace();
					}
				}
				else
					return false;
			}
			catch(PlinguaCoreException ex1)
			{
				ex1.printStackTrace();
			}
		
		return false;
	}
	
	
	

	public Psystem getPsystem() {
		return psystem;
	}

	public PrintStream getErrorPrintStream() {
		return printStream;
	}
	public PrintStream getWarningPrintStream() {
		return printStream1;
	}
	public PrintStream getMsgPrintStream() {
		return printStream2;
	}

}
